Package org.zkoss.bind.paranamer

## Interface Paranamer

- All Known Implementing Classes:
    `AdaptiveParanamer`, `BytecodeReadingParanamer`, `CachingParanamer`, `CachingParanamer.WithoutWeakReferences`, `ParameterReflectionParanamer`

      public interface Paranamer

  Paranamer allows lookups of methods and constructors by parameter names.
  Author:
    Paul Hammant, Mauro Talevi

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String[]` | `EMPTY_NAMES` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String[]` | `lookupParameterNames​(java.lang.reflect.AccessibleObject methodOrConstructor)` | Lookup the parameter names of a given method.
    `java.lang.String[]` | `lookupParameterNames​(java.lang.reflect.AccessibleObject methodOrConstructor, boolean throwExceptionIfMissing)` | Lookup the parameter names of a given method.

- - ### Field Detail

    - #### EMPTY_NAMES

          static final java.lang.String[] EMPTY_NAMES

  - ### Method Detail

    - #### lookupParameterNames

          java.lang.String[] lookupParameterNames​(java.lang.reflect.AccessibleObject methodOrConstructor)

      Lookup the parameter names of a given method.
      Parameters:
        `methodOrConstructor` - the `Method` or `Constructor` for which the parameter names are looked up.
      Returns:
        A list of the parameter names.
      Throws:
        `ParameterNamesNotFoundException` - if no parameter names were found.
        `java.lang.NullPointerException` - if the parameter is null.
        `java.lang.SecurityException` - if reflection is not permitted on the containing `Class` of the parameter

    - #### lookupParameterNames

          java.lang.String[] lookupParameterNames​(java.lang.reflect.AccessibleObject methodOrConstructor,
                                                  boolean throwExceptionIfMissing)

      Lookup the parameter names of a given method.
      Parameters:
        `methodOrConstructor` - the `Method` or `Constructor` for which the parameter names are looked up.
        `throwExceptionIfMissing` - whether to throw an exception if no Paranamer data found (versus return null).
      Returns:
        A list of the parameter names.
      Throws:
        `ParameterNamesNotFoundException` - if no parameter names were found.
        `java.lang.NullPointerException` - if the parameter is null.
        `java.lang.SecurityException` - if reflection is not permitted on the containing `Class` of the parameter